/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 28.10.2009
Author  : XAKEP
Company : XAKEP-COMPANY
Comments: 


Chip type               : ATtiny13
AVR Core Clock frequency: 0,500000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/
#include <tiny13.h>
#include <m8_128.h>

#include <delay.h>

#define ADC_VREF_TYPE 0x20

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}

// Declare your global variables here
//unsigned int volt;
//unsigned char i;

unsigned char real_volt(void)
{
  unsigned char volt[16];
  unsigned char i, sred;
  unsigned int sum;
  sum=0;
  for (i=0; i<16; i++)
  {
    volt[i]=read_adc(2);
    sum=sum+volt[i];
  }
  sred=(sum>>4);
  for (i=0; i<16; i++)
  {
    if (sred>(volt[i]+(volt[i]>>4))) {volt[i]=sred;}
    if (sred<(volt[i]-(volt[i]>>4))) {volt[i]=sred;}
  }
  sum=0;
  for (i=0; i<16; i++) sum=sum+volt[i];
  return (sum>>4);
}

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 8
#pragma optsize-
CLKPR=0x80;
CLKPR=0x03;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Reset Source checking
if (MCUSR & 1)
   {
   // Power-on Reset
   MCUSR=0;
   // Place your code here

   }
else if (MCUSR & 2)
   {
   // External Reset
   MCUSR=0;
   // Place your code here

   }
else if (MCUSR & 4)
   {
   // Brown-Out Reset
   MCUSR=0;
   // Place your code here

   }
else
   {
   // Watchdog Reset
   MCUSR=0;
   // Place your code here

   };

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 150,000 kHz
// ADC Bandgap Voltage Reference: Off
// ADC Auto Trigger Source: None
// Only the 8 most significant bits of
// the AD conversion result are used
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0&=0x03;
DIDR0|=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;


while (1)
    {
      // Place your code here
//      volt=0;
//      for (i=0; i<4; i++) {volt=volt+read_adc(2);};
//      volt=volt/128;
//      volt=sum()/32;       
      PORTB=PORTB|(real_volt()>>5);
      delay_ms(200);
      PORTB=PORTB&0b01110000;
    };
}